#!/usr/bin/perl

#┌─────────────────────────────────
#│ ImageAlbum v4.02 : check.cgi - 2013/01/03
#│ Copyright (c) KentWeb
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Image Album v5.2 : check.cgi - 2022/10/01
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);

# 外部ファイル取り込み
require './init.cgi';
my %cf = set_init();

print <<EOM;
Content-type: text/html; charset=utf-8

<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="utf-8">
<title>Check Mode</title>
</head>
<body>
<b>Check Mode: [ $cf{version} ]</b>
<ul>
<li>Perlバージョン : $]
EOM

# ディレクトリ
my %dir = (
	$cf{upldir}               => '画像ディレクトリ',
	$cf{resupldir}            => '返信画像ディレクトリ',
	$cf{cmnurl}               => '共用ディレクトリ',
	$cf{datadir}              => 'データディレクトリ',
	"$cf{logdir}/data"        => '返信ログディレクトリ',
	"$cf{admin_datadir}/pwd"  => '管理パスワードディレクトリ',
	"$cf{admin_datadir}/ses"  => '管理パスワードセッションディレクトリ',
	);
for ( keys %dir ) {
	if (-d $_) {
		print "<li>$dir{$_}パス : OK\n";
		#next if ($_ eq $cf{datadir});
		
		if (-r $_ && -w $_ && -x $_) {
			print "<li>$dir{$_}パーミッション : OK\n";
		} else {
			print "<li>$dir{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$dir{$_}パス : NG\n";
	}
}

# データファイル
my %log = (
	"$cf{logdir}/data.cgi"          => '記事ログファイル',
	"$cf{logdir}/cate.dat"          => 'カウントファイル',
	"$cf{logdir}/num.dat"           => 'ユーザー登録アイコンファイル',
	"$cf{admin_datadir}/ses.cgi"    => 'ログインセッションファイル',
	"$cf{admin_datadir}/pass.dat"   => '管理パスワードデータファイル',
	);
for ( keys %log ) {
	if (-f $_) {
		print "<li>$log{$_}パス : OK\n";
		if (-r $_ && -w $_) {
			print "<li>$log{$_}パーミッション : OK\n";
		} else {
			print "<li>$log{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$log{$_}パス : NG\n";
	}
}

# テンプレート
for (qw(album cate error message read archv enter res res_edit res_pwdform)) {
	if (-f "$cf{tmpldir}/$_.html") {
		print "<li>テンプレート( $_.html ) : OK\n";
	} else {
		print "<li>テンプレート( $_.html ) : NG\n";
	}
}

# Image-Magick動作確認
eval { require Image::Magick; };
if ($@) {
	print "<li>Image-Magick動作: NG\n";
} else {
	print "<li>Image-Magick動作: OK\n";
}

print <<EOM;
</ul>
</body>
</html>
EOM
exit;


