#!/usr/bin/perl

#┌─────────────────────────────────
#│ Image Album v5.2 : edit.cgi - 2022/10/01
#│ Copyright (c) TRANSFORM Since 2012
#│ https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;
use File::ReadBackwards;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# 処理分岐
if ($in{mode} eq 'com_del') { com_del(); }
if ($in{mode} eq 'com_edit') { com_edit(); }

error("不明な処理です");

#-----------------------------------------------------------
#  コメント返信削除
#-----------------------------------------------------------
sub com_del {
	# 入力チェック
	$in{num} =~ s/\D//g;

	# 汚染チェック
	my $resfile;
	if ($in{no} =~ /^(\d+)$/) {
		$resfile = "$cf{datadir}/$1.cgi";
	} else {
		error("不正なアクセスです");
	}

	if ($in{num} eq '' || $in{pwd} eq '') {
		error("削除Noまたは削除キーが入力モレです");
	}

	my ($flg,$crypt,$ext,@log);
	open(DAT,"+< $cf{datadir}/$in{no}.cgi") or error("open err: $cf{datadir}/$in{no}.cgi");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$date,$name,$msg,$url,$host,$time,$cat,$ex,$w,$h,$pw) = split(/<>/);

		if ($in{num} == $no) {
			$flg++;
			$crypt = $pw;
			$ext = $ex;
			next;
		}
		push(@log,$_);
	}

	if (!$flg || $crypt eq '') {
		close(DAT);
		error("削除キーが設定されていないか、該当記事が見当たりません");
	}

	# 削除キーを照合
	if (decrypt($in{pwd}, $crypt) != 1) {
		close(DAT);
		error("認証できません");
	}

	# 返信ログを更新
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 添付削除
	if ($ext) {
		unlink("$cf{resupldir}/$in{no}-$in{num}$ext");
		unlink("$cf{resupldir}/$in{no}-$in{num}-s$ext") if (-f "$cf{resupldir}/$in{no}-$in{num}-s$ext");
	}

		# レス数
		my $new_res = @log;

		# indexデータ
		my @file;
		open(DAT,"+< $cf{datfile}") or &error("open err: $cf{datfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			chomp;
			my ($no,$sub,$msg,$ex,$w,$h,$res,$time,$cat) = split(/<>/);

			if ($in{no} == $no) {
				$_ = "$no<>$sub<>$msg<>$ex<>$w<>$h<>$new_res<>$time<>$cat<>";
			}
			push(@file,"$_\n");
		}
		seek(DAT, 0, 0);
		print DAT @file;
		truncate(DAT, tell(DAT));
		close(DAT);

	message("コメントを削除しました");
}

#-----------------------------------------------------------
#  コメント返信修正
#-----------------------------------------------------------
sub com_edit {

	# 入力チェック
	$in{num} =~ s/\D//g;

	# 汚染チェック
	my $resfile;
	if ($in{no} =~ /^(\d+)$/) {
		$resfile = "$cf{datadir}/$1.cgi";
	} else {
		error("不正なアクセスです");
	}

	if ($in{num} eq '' || $in{pwd} eq '') {
		error("コメントNo又は暗証キーが入力されていません");
	}

	# 実行
	if ($in{job} eq "edit") {

	# 日本語チェック
	if ($cf{jp_word_chk}) {
		if ($in{comment} !~ /(?:[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3})/) {
			error("本文に日本語が含まれていません");
		}
	}
	
	# 禁止ワードチェック
	my $flg;
	for ( split(/\s+/,$cf{bad_word}) ) {
		if (index($in{comment},$_) >= 0) {
			$flg++;
			last;
		}
	}
	if ($flg) { error('コメントに禁止ワードが含まれているため受付できません!'); }
	
	# ホストチェック
	my ($addr,$host) = get_host();
	my $flg;
	for ( split(/\s+/,$cf{bad_host}) ) {
		if (index($host,$_) >= 0 or index($addr,$_) >= 0) {
			$flg++;
			last;
		}
	}
	if ($flg) { error('コメントは受付できません!!'); }

	# 不要改行カット
	$in{name} =~ s/<br>//g;
	$in{pwd}  =~ s/<br>//g;
	$in{captcha} =~ s/<br>//g;
	$in{comment} =~ s/(<br>)+$//g;

	# 入力値調整
	if ($in{url} eq 'http://') { $in{url} = ''; }

	# フォーム内容をチェック
	my $err;
	if ($in{name} eq "") { $err .= "名前が入力されていません<br>"; }
	if ($in{comment} eq "") { $err .= "コメントが入力されていません<br>"; }
	if ($in{url} ne '' && $in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "参照先URLの入力内容が不正です<br>";
	}
	if ($err) { error($err); }

		my ($flg, $ext2,$w2,$h2,@data);
		open(DAT,"+< $resfile") || &error("Open Error: $resfile");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($num,$date,$name,$msg,$url,$host,$time,$cat,$ex,$w,$h,$pw) = split(/<>/);

			if ($in{num} == $num) {
			$flg = 1;
			# アップロード
			if ($in{upfile}) {
				($ext2,$w2,$h2) = res_upload($num);
			}

			# 画像削除
			if ($in{imgdel}) {
				unlink("$cf{resupldir}/$in{no}-$num$ex");
				unlink("$cf{resupldir}/$in{no}-$num-s$ex") if (-f "$cf{resupldir}/$in{no}-$num-s$ex");
				$ex = $w = $h = '';
			}

			# 添付アップロードの場合
			if ($ext2) {
				# 拡張子変更の場合旧ファイル削除
				if ($ex && $ext2 ne $ex) {
					unlink("$cf{resupldir}/$in{no}-$num$ex");
					unlink("$cf{resupldir}/$in{no}-$num-s$ex") if (-f "$cf{resupldir}/$in{no}-$num-s$ex");
				}
				# 新添付ファイル情報
				($ex,$w,$h) = ($ext2,$w2,$h2);
			}
				$_ = "$num<>$date<>$in{name}<>$in{comment}<>$in{url}<>$host<>$time<>$cat<>$ex<>$w<>$h<>$pw<>\n";
			}
			push(@data,$_);
		}

		if ($flg != 1) {
			close(DAT);
			error("不正な処理です");
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("コメントの修正を完了しました");
	}

	my ($flg, @edit);
	open(IN,"$resfile") || &error("Open Error: $resfile");
	while (<IN>) {
		my ($num,$date,$name,$msg,$url,$host,$time,$cat,$ex,$w,$h,$pw) = split(/<>/);

		if ($in{num} == $num) {

			# 暗証キーなし
			if ($pw eq '') {
				$flg = 2;
			} elsif

			# 暗証キー一致
			(decrypt($in{pwd}, $pw) == 1) {
				$flg = 1;
				@edit = ($num,$date,$name,$msg,$url,$host,$time,$cat,$ex,$w,$h,$pw);

			# 暗証キー不一致
			} else {
				$flg = 3;
			}
			last;
		}
	}
	close(IN);

	if (!$flg) {
		close(DAT);
		error("該当コメントが見当たりません");
	} elsif ($flg == 2) {
		close(DAT);
		error("このコメントには暗証キーが設定されていません");
	} elsif ($flg == 3) {
		close(DAT);
		error("暗証キーが違います");
	}

	# 改行復元
	my ($num,$date,$name,$msg,$url,$host,$time,$cat,$ex,$w,$h,$pw) = split(/<>/,);
	$msg =~ s|<br( /)?>|\n|g;
	$url ||= 'http://';

	# 画像認証作成
	my ($str_plain,$str_crypt,$regikey,$JavaScript);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt, $regikey, $JavaScript) = cap::make( $cf{captcha_key}, $cf{cap_len} );
		$JavaScript=&mkJavaScript($regikey,'myFORM') if($cf{cap_len} == 3);
	}

	# 添付ファイル
	my $attach;
	if ($ex) {
		$attach .= qq|&nbsp; [<a href="$cf{resupldir}/$in{no}-$num$ex" target="_blank">添付</a>]\n|;
		$attach .= qq|<input type="checkbox" name="imgdel" value="1">削除\n|;
	}

	# 修正フォーム
	open(IN,"$cf{tmpldir}/res_edit.html") or &error("open err: res_edit.html");
	print "Content-type: text/html; charset=utf-8\n\n";
	while(<IN>) {
                s/!str_crypt!/$str_crypt/g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!cgi_title!/$cf{cgi_title}/g;
		s/!ttl_msg!/$cf{ttl_msg}/g;
		s|!album_css!|$cf{cmnurl}/album.css|g;
		s/!no!/$in{no}/g;
		s/!num!/$num/g;
		s/!pwd!/$pw/g;
		s/!name!/$name/g;
		s/!comment!/$msg/g;
		s/!url!/$url/g;
		s/<!-- attach -->/$attach/g;
		print;
	}
	close(IN);

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  アクセス制限
#-----------------------------------------------------------
sub get_host {
	# IP&ホスト取得
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}

	# IPチェック
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg = 1; last; }
	}
	if ($flg) {
		&error("アクセスを許可されていません");

	# ホストチェック
	} elsif ($host) {

		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($host =~ /$_$/i) { $flg = 1; last; }
		}
		if ($flg) {
			&error("アクセスを許可されていません");
		}
	}
	if ($host eq "") { $host = $addr; }
	return ($host,$addr);
}

#-----------------------------------------------------------
#  crypt暗号
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in, $salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  crypt照合
#-----------------------------------------------------------
sub decrypt {
	my ($in, $dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);
	if (crypt($in, $salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  コメント返信添付アップロード
#-----------------------------------------------------------
sub res_upload {
	my $num = shift;

	my $resnum;
	if ($in{no} =~ /^(\d+)$/) {
		$resnum = "$1";
	}

	my $fname = $cgi->param_filename('upfile');
	if ($fname =~ /(\.jpe?g|\.png|\.gif|\.bmp)$/i) {
		my $ex = $1;
		if ($ex eq '.jpeg') { $ex = '.jpg'; }

		# アップファイル定義
		my $imgfile = "$cf{resupldir}/$resnum-$num$ex";

		# 書き込み
		open(UP,"+> $imgfile") or error("up err: $imgfile");
		binmode(UP);
		print UP $in{upfile};
		close(UP);

		# 画像サイズ取得
		my ($w,$h);
		if ($ex eq ".jpg") { ($w,$h) = &j_size($imgfile); }
		elsif ($ex eq ".gif") { ($w,$h) = &g_size($imgfile); }
		elsif ($ex eq ".png") { ($w,$h) = &p_size($imgfile); }
		elsif ($ex eq ".bmp") { ($w,$h) = &b_size($imgfile); }

		chmod(0666,$imgfile);

		return ($ex,$w,$h);
	}
	return;
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  BMPサイズ
#-----------------------------------------------------------
sub b_size {
	my $bmp = shift;

	my $buf;
	open(BMP, "$bmp") || return (0,0);
	binmode(BMP);
	seek(BMP, 0, 0);
	read(BMP, $buf, 6);
	seek(BMP, 12, 1);
	read(BMP, $buf, 8);
	my ($w, $h) = unpack("VV", $buf);

	return ($w, $h);
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!album_cgi!/$cf{album_cgi}/g;
	$tmpl =~ s/!cgi_title!/$cf{cgi_title}/g;
	$tmpl =~ s|!album_css!|$cf{cmnurl}/album.css|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my ($msg) = @_;

	open(IN,"$cf{tmpldir}/message.html") or error("open err: message.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!message!/$msg/g;
	$tmpl =~ s/!album_cgi!/$cf{album_cgi}/g;
	$tmpl =~ s/!cgi_title!/$cf{cgi_title}/g;
	$tmpl =~ s|!album_css!|$cf{cmnurl}/album.css|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
 [ <a href="https://www.kent-web.com/" target="_top">ImageAlbum : オリジナル公開終了</a> ]<br />
- <a href="https://www.transformsite.com/" target="_top">$cf{version} - Edited by TRANSFORM</a> -
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

